package com.letmetrial.api.auth.usecase;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.springframework.stereotype.Component;

import com.letmetrial.api.auth.client.keycloak.KeycloakClient;

import lombok.RequiredArgsConstructor;

@RequiredArgsConstructor
@Component
public class AtualizarTokenUC {

    private final AtualizarTokenUCMapper mapper;

    private final KeycloakClient keycloakClient;

    public TokenDTO run(String refreshToken) {
        return mapper.toTokenDTO(keycloakClient.refreshToken(refreshToken));
    }

    public record TokenDTO(String accessToken,
            Long expiresIn,
            Long refreshExpiresIn,
            String refreshToken,
            String tokenType,
            String sessionState,
            String scope) {
    }

    @Mapper
    public interface AtualizarTokenUCMapper {

        @Mapping(target = "accessToken", source = "access_token")
        @Mapping(target = "expiresIn", source = "expires_in")
        @Mapping(target = "refreshExpiresIn", source = "refresh_expires_in")
        @Mapping(target = "refreshToken", source = "refresh_token")
        @Mapping(target = "tokenType", source = "token_type")
        @Mapping(target = "sessionState", source = "session_state")
        TokenDTO toTokenDTO(com.letmetrial.api.auth.client.keycloak.dto.TokenDTO tokenDTO);

    }

}
